// class detectResize() {
//   constructor() {

//   }
// }

{
  var attachEvent = document.attachEvent;
  var isIE = navigator.userAgent.match(/Trident/);
  
  function resizeListener(element, e) {
    var win = e.target || e.srcElement;

    if(win.__resizeRAF__) {
      cancelAnimationFrame(win.__resizeRAF__);
    }
    
    win.__resizeRAF__ = requestAnimationFrame(function() {
      
      var trigger = win.__resizeTrigger__;
      
      trigger.__resizeListeners__.forEach(fn => {
        fn.call(trigger, element);
      });
    });
  }
    
  function objectLoad(element, e) {
    this.contentDocument.defaultView.__resizeTrigger__ = this.__resizeElement__;
    this.contentDocument.defaultView.addEventListener('resize', resizeListener.bind(null, element));
  }
  
  window.addResizeListener = function(element, fn) {
    if(!element.__resizeListeners__) {
      
      element.__resizeListeners__ = [];
      
      if(attachEvent) {
        element.__resizeTrigger__ = element;
        element.attachEvent('onresize', resizeListener);
      }
      else {
        if(getComputedStyle(element).position == 'static') element.style.position = 'relative';

          var obj = element.__resizeTrigger__ = document.createElement('object'); 
          
          obj.setAttribute('style', 'display: block; position: absolute; top: 0; left: 0; height: 100%; width: 100%; overflow: hidden; pointer-events: none; z-index: -1;');
          obj.__resizeElement__ = element;
          obj.tabIndex = -1;
          obj.onload = objectLoad.bind(obj, element);
          obj.type = 'text/html';
          
          if(!isIE) obj.data = 'about:blank';

          element.appendChild(obj);
      }
    }
    element.__resizeListeners__.push(fn);
  };
  
  window.removeResizeListener = function(element, fn) {
    element.__resizeListeners__.splice(element.__resizeListeners__.indexOf(fn), 1);
    if(!element.__resizeListeners__.length) {
      if(attachEvent) {
        element.detachEvent('onresize', resizeListener);
      }
      else {
        element.__resizeTrigger__.contentDocument.defaultView.removeEventListener('resize', resizeListener);
        element.__resizeTrigger__ = !element.removeChild(element.__resizeTrigger__);
      }
    }
  }
}